## python3.7 3.7.5

=== Doc/Makefile ===
#
# Makefile for Python documentation
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#

# You can set these variables from the command line.
PYTHON       = python3
VENVDIR      = ./venv
SPHINXBUILD  = PATH=$(VENVDIR)/bin:$$PATH sphinx-build
BLURB        = PATH=$(VENVDIR)/bin:$$PATH blurb
PAPER        =
SOURCES      =
DISTVERSION  = $(shell $(PYTHON) tools/extensions/patchlevel.py)

# Internal variables.
PAPEROPT_a4     = -D latex_elements.papersize=a4paper
PAPEROPT_letter = -D latex_elements.papersize=letterpaper

ALLSPHINXOPTS = -b $(BUILDER) -d build/doctrees $(PAPEROPT_$(PAPER)) \
                $(SPHINXOPTS) . build/$(BUILDER) $(SOURCES)

.PHONY: help build html htmlhelp latex text changes linkcheck \
	suspicious coverage doctest pydoc-topics htmlview clean dist check serve \
	autobuild-dev autobuild-stable venv

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  clean      to remove build files"
	@echo "  venv       to create a venv with necessary tools"
	@echo "  html       to make standalone HTML files"
	@echo "  htmlview   to open the index page built by the html target in your browser"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  text       to make plain text files"
	@echo "  epub       to make EPUB files"
	@echo "  changes    to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  coverage   to check documentation coverage for library and C API"
	@echo "  doctest    to run doctests in the documentation"
	@echo "  pydoc-topics  to regenerate the pydoc topics file"
	@echo "  dist       to create a \"dist\" directory with archived docs for download"
	@echo "  suspicious to check for suspicious markup in output text"
	@echo "  check      to run a check for frequent markup errors"
	@echo "  serve      to serve the documentation on the localhost (8000)"

build:
	-mkdir -p build
# Look first for a Misc/NEWS file (building from a source release tarball
# or old repo) and use that, otherwise look for a Misc/NEWS.d directory
# (building from a newer repo) and use blurb to generate the NEWS file.
	@if [ -f  ../Misc/NEWS ] ; then \
		echo "Using existing Misc/NEWS file"; \
		cp ../Misc/NEWS build/NEWS; \
	elif [ -d ../Misc/NEWS.d ]; then \
		echo "Building NEWS from Misc/NEWS.d with blurb"; \
		$(BLURB) merge -f build/NEWS; \
	else \
		echo "Neither Misc/NEWS.d nor Misc/NEWS found; cannot build docs"; \
		exit 1; \
	fi
	$(SPHINXBUILD) $(ALLSPHINXOPTS)
	@echo

html: BUILDER = html
html: build
	@echo "Build finished. The HTML pages are in build/html."

htmlhelp: BUILDER = htmlhelp
htmlhelp: build
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      "build/htmlhelp/pydoc.hhp project file."

latex: BUILDER = latex
latex: build
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

text: BUILDER = text
text: build
	@echo "Build finished; the text files are in build/text."

epub: BUILDER = epub
epub: build
	@echo "Build finished; the epub files are in build/epub."

changes: BUILDER = changes
changes: build
	@echo "The overview file is in build/changes."

linkcheck: BUILDER = linkcheck
linkcheck:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Link check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/output.txt"; \
	false; }

suspicious: BUILDER = suspicious
suspicious:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Suspicious check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/suspicious.csv.  If all issues are false" \
	     "positives, append that file to tools/susp-ignored.csv."; \
	false; }

coverage: BUILDER = coverage
coverage: build
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

doctest: BUILDER = doctest
doctest:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Testing of doctests in the sources finished, look at the" \
	     "results in build/doctest/output.txt"; \
	false; }

pydoc-topics: BUILDER = pydoc-topics
pydoc-topics: build
	@echo "Building finished; now run this:" \
	      "cp build/pydoc-topics/topics.py ../Lib/pydoc_data/topics.py"

htmlview: html
	 $(PYTHON) -c "import webbrowser; webbrowser.open('build/html/index.html')"

clean:
	-rm -rf build/* $(VENVDIR)/*

venv:
	$(PYTHON) -m venv $(VENVDIR)
	$(VENVDIR)/bin/python3 -m pip install -U Sphinx blurb
	@echo "The venv has been created in the $(VENVDIR) directory"

dist:
	rm -rf dist
	mkdir -p dist

	# archive the HTML
	make html
	cp -pPR build/html dist/python-$(DISTVERSION)-docs-html
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-html.tar python-$(DISTVERSION)-docs-html
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-html.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-html.zip python-$(DISTVERSION)-docs-html)
	rm -r dist/python-$(DISTVERSION)-docs-html
	rm dist/python-$(DISTVERSION)-docs-html.tar

	# archive the text build
	make text
	cp -pPR build/text dist/python-$(DISTVERSION)-docs-text
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-text.tar python-$(DISTVERSION)-docs-text
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-text.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-text.zip python-$(DISTVERSION)-docs-text)
	rm -r dist/python-$(DISTVERSION)-docs-text
	rm dist/python-$(DISTVERSION)-docs-text.tar

	# archive the A4 latex
	rm -rf build/latex
	make latex PAPER=a4
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-a4.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-a4.tar.bz2

	# archive the letter latex
	rm -rf build/latex
	make latex PAPER=letter
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-letter.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-letter.tar.bz2

	# copy the epub build
	rm -rf build/epub
	make epub
	cp -pPR build/epub/Python.epub dist/python-$(DISTVERSION)-docs.epub

check:
	$(PYTHON) tools/rstlint.py -i tools -i $(VENVDIR) -i README.rst

serve:
	../Tools/scripts/serve.py build/html

# Targets for daily automated doc build
# By default, Sphinx only rebuilds pages where the page content has changed.
# This means it doesn't always pick up changes to preferred link targets, etc
# To ensure such changes are picked up, we build the published docs with
# `-E` (to ignore the cached environment) and `-a` (to ignore already existing
# output files)

# for development releases: always build
autobuild-dev:
	make dist SPHINXOPTS='$(SPHINXOPTS) -Ea -A daily=1 -A switchers=1'
	-make suspicious

# for quick rebuilds (HTML only)
autobuild-dev-html:
	make html SPHINXOPTS='$(SPHINXOPTS) -Ea -A daily=1 -A switchers=1'

# for stable releases: only build if not in pre-release stage (alpha, beta)
# release candidate downloads are okay, since the stable tree can be in that stage
autobuild-stable:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev

autobuild-stable-html:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev-html

## python3.7 3.7.0~a2

=== debian/changelog ===
python3.7 (3.7.0~a2-1) experimental; urgency=medium

  * Python 3.7.0 alpha 2 release.

 -- Matthias Klose <doko@debian.org>  Wed, 18 Oct 2017 20:58:26 +0200

python3.7 (3.7.0~a1-2) experimental; urgency=medium

  * Build with -fstack-protector instead of -fstack-protector-strong.
    Performance improvements of around 1-2% according to LP #1638695.

 -- Matthias Klose <doko@debian.org>  Wed, 20 Sep 2017 14:12:51 +0200

python3.7 (3.7.0~a1-1) experimental; urgency=medium

  * Python 3.7.0 alpha 1 release.
  * Explicitly use the system python for byte compilation in postinst scripts.
    Addresses: #852163. LP: #1682934.
  * Build using -fexceptions on ppc64 and ppc64el.
    Addresses: #862925. LP: #1691848.

 -- Matthias Klose <doko@debian.org>  Wed, 20 Sep 2017 14:12:51 +0200

python3.7 (3.7-20170522-1) experimental; urgency=medium

  * Python 3.7 snapshot 20170522.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 May 2017 14:32:31 -0700

python3.6 (3.6.0~b4-1) experimental; urgency=medium

  * Python 3.6.0 beta 4.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Tue, 22 Nov 2016 14:41:03 +0100

python3.6 (3.6.0~b3-1) experimental; urgency=medium

  * Python 3.6.0 beta 3.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Wed, 02 Nov 2016 14:33:32 +0200

python3.6 (3.6.0~b2-1) experimental; urgency=medium

  * Python 3.6.0 beta 2.

 -- Matthias Klose <doko@debian.org>  Tue, 11 Oct 2016 07:27:10 +0200

python3.6 (3.6.0~b1-1) experimental; urgency=medium

  * Python 3.6.0 beta 1.
  * Don't build the fpectl module on hppa. Addresses: #837314.

 -- Matthias Klose <doko@debian.org>  Tue, 13 Sep 2016 13:59:11 +0200

python3.6 (3.6.0~a4-1) experimental; urgency=medium

  * Python 3.6.0 alpha 4.

 -- Matthias Klose <doko@debian.org>  Tue, 16 Aug 2016 08:29:13 +0200

python3.6 (3.6.0~a3-1) experimental; urgency=medium

  * Python 3.6.0 alpha 3.

 -- Matthias Klose <doko@debian.org>  Mon, 25 Jul 2016 11:12:59 +0200

python3.6 (3.6.0~a2-1) experimental; urgency=medium

  * Python 3.6.0 alpha 2.
  * Update to 20160614 from the trunk.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Tue, 14 Jun 2016 13:36:38 +0200

python3.6 (3.6.0~a1-1) experimental; urgency=medium

  * Python 3.6.0 alpha 1.

 -- Matthias Klose <doko@debian.org>  Wed, 18 May 2016 10:11:08 +0200

python3.5 (3.5.1-12) unstable; urgency=medium

  * Update to 20160509 from the 3.5 branch.
    - Issue #26811: gc.get_objects() no longer contains a broken tuple with
      NULL pointer.
    - Issue #20120: Use RawConfigParser for .pypirc parsing, removing support
      for interpolation unintentionally added with move to Python 3. Behavior
      no longer does any interpolation in .pypirc files, matching behavior in
      Python 2.7 and Setuptools 19.0.
    - Issue #25745: Fixed leaking a userptr in curses panel destructor.
    - Issue #26881: The modulefinder module now supports extended opcode
      arguments.
    - Issue #23815: Fixed crashes related to directly created instances of
      types in _tkinter and curses.panel modules.
    - Issue #17765: weakref.ref() no longer silently ignores keyword arguments.
    - Issue #26873: xmlrpc now raises ResponseError on unsupported type tags
      instead of silently return incorrect result.
    - Issue #26881: modulefinder now works with bytecode with extended args.
    - Issue #26711: Fixed the comparison of plistlib.Data with other types.
    - Issue #24114: Fix an uninitialized variable in `ctypes.util`.
    - Issue #26864: In urllib.request, change the proxy bypass host checking
      against no_proxy to be case-insensitive, and to not match unrelated host
      names that happen to have a bypassed hostname as a suffix.
    - Issue #26634: recursive_repr() now sets __qualname__ of wrapper.
    - Issue #26804: urllib.request will prefer lower_case proxy environment
      variables over UPPER_CASE or Mixed_Case ones.
    - Issue #26837: assertSequenceEqual() now correctly outputs non-stringified
      differing items (like bytes in the -b mode).
      This affects assertListEqual() and assertTupleEqual().
    - Issue #26041: Remove "will be removed in Python 3.7" from deprecation
      messages of platform.dist() and platform.linux_distribution().
    - Issue #26822: itemgetter, attrgetter and methodcaller objects no longer
      silently ignore keyword arguments.
    - Issue #26733: Disassembling a class now disassembles class and static
      methods.
    - Issue #26801: Fix error handling in :func:`shutil.get_terminal_size`,
      catch :exc:`AttributeError` instead of :exc:`NameError`.
    - Issue #24838: tarfile's ustar and gnu formats now correctly calculate name
      and link field limits for multibyte character encodings like utf-8.
    - Issue #26657: Fix directory traversal vulnerability with http.server on
      Windows.
    - Issue #26736: Used HTTPS for external links in the documentation if
      possible.
    - Issue #22359: Disable the rules for running _freeze_importlib and pgen
      when cross-compiling.  The output of these programs is normally saved
      with the source code anyway, and is still regenerated when doing a
      native build. Closes: #820509.
    - Issue #21668: Link audioop, _datetime, _ctypes_test modules to libm.
    - Issue #26799: Fix python-gdb.py: don't get C types once when the Python
      code is loaded, but get C types on demand. The C types can change if
      python-gdb.py is loaded before the Python executable.
  * Fix issue #26673, runtime error in idle3. LP: #1574892.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Mon, 09 May 2016 13:00:17 +0200

python3.5 (3.5.1-11) unstable; urgency=medium

  * Update to 20160330 from the 3.5 branch.
    - Issue #26659: Make the builtin slice type support cycle collection.
    - Issue #26718: super.__init__ no longer leaks memory if called multiple
      times.  NOTE: A direct call of super.__init__ is not endorsed!


=== debian/control ===
Source: python3.7
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.17.11),
  quilt, autoconf,
  lsb-release, sharutils,
  libreadline-dev, libncursesw5-dev (>= 5.3), 
  zlib1g-dev, libbz2-dev, liblzma-dev,
  libgdbm-dev, libdb-dev,
  tk-dev, blt-dev (>= 2.4z), libssl-dev,
  libexpat1-dev, libmpdec-dev (>= 2.4),
  libbluetooth-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
  locales [!armel !avr32 !hppa !ia64 !mipsel],
  libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k !avr32],
  libgpm2 [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
  mime-support, netbase, bzip2, time, python3:any,
  net-tools, xvfb, xauth
Build-Depends-Indep: python3-sphinx
Standards-Version: 4.1.0
Vcs-Browser: https://code.launchpad.net/~doko/python/pkg3.7-debian
Vcs-Bzr: http://bazaar.launchpad.net/~doko/python/pkg3.7-debian
XS-Testsuite: autopkgtest

Package: python3.7
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.7-minimal (= ${binary:Version}), libpython3.7-stdlib (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
Suggests: python3.7-venv, python3.7-doc, binutils
Description: Interactive high-level object-oriented language (version 3.7)
 Python is a high-level, interactive, object-oriented language. Its 3.7 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.

Package: python3.7-venv
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.7 (= ${binary:Version}),
 python-pip-whl (>= 8.1.0-2), ${shlibs:Depends}, ${misc:Depends},
Breaks: python3-pip (<< 1.5.6-4)
Description: Interactive high-level object-oriented language (pyvenv binary, version 3.7)
 Python is a high-level, interactive, object-oriented language. Its 3.7 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the pyvenv-3.7 binary.

Package: libpython3.7-stdlib
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.7-minimal (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
Breaks: libmpdec2 (<< 2.4.2)
Description: Interactive high-level object-oriented language (standard library, version 3.7)
 Python is a high-level, interactive, object-oriented language. Its 3.7 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains Python 3.7's standard library. It is normally not
 used on its own, but as a dependency of python3.7.

Package: python3.7-minimal
Architecture: any
Multi-Arch: allowed
Priority: optional
Pre-Depends: ${shlibs:Pre-Depends}
Depends: libpython3.7-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.7
Suggests: binfmt-support
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.7)
 This package contains the interpreter and some essential modules.  It can
 be used in the boot process for some basic tasks.
 See /usr/share/doc/python3.7-minimal/README.Debian for a list of the modules
 contained in this package.

Package: libpython3.7-minimal
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libpython3.7-stdlib
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.7)
 This package contains some essential modules. It is normally not
 used on it's own, but as a dependency of python3.7-minimal.

Package: libpython3.7
Architecture: any
Multi-Arch: same
Section: libs
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.7-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Shared Python runtime library (version 3.7)
 Python is a high-level, interactive, object-oriented language. Its 3.7 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the shared runtime library, normally not needed
 for programs using the statically linked interpreter.

Package: python3.7-examples
Architecture: all
Depends: python3.7 (>= ${source:Version}), ${misc:Depends}
Description: Examples for the Python language (v3.7)
 Examples, Demos and Tools for Python (v3.7). These are files included in
 the upstream Python distribution (v3.7).

Package: python3.7-dev
Architecture: any
Multi-Arch: allowed
Depends: python3.7 (= ${binary:Version}), libpython3.7-dev (= ${binary:Version}), libpython3.7 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.7)
 Header files, a static library and development tools for building
 Python (v3.7) modules, extending the Python interpreter or embedding
 Python (v3.7) in applications.
 .
 Maintainers of Python packages should read README.maintainers.

Package: libpython3.7-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.7-stdlib (= ${binary:Version}), libpython3.7 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.7)
 Header files, a static library and development tools for building
 Python (v3.7) modules, extending the Python interpreter or embedding
 Python (v3.7) in applications.
 .
 Maintainers of Python packages should read README.maintainers.
 .
 This package contains development files. It is normally not
 used on it's own, but as a dependency of python3.7-dev.

Package: libpython3.7-testsuite
Section: libdevel
Architecture: all
Depends: python3.7 (>= ${binary:Version}), ${misc:Depends}, net-tools
Suggests: python3-gdbm, python3-tk
Description: Testsuite for the Python standard library (v3.7)
 The complete testsuite for the Python standard library.  Note that
 a subset is found in the libpython3.7-stdlib package, which should
 be enough for other packages to use (please do not build-depend
 on this package, but file a bug report to include additional 
 testsuite files in the libpython3.7-stdlib package).

Package: idle-python3.7
Architecture: all
Depends: python3.7, python3-tk, python3.7-tk, ${misc:Depends}
Enhances: python3.7
Description: IDE for Python (v3.7) using Tkinter
 IDLE is an Integrated Development Environment for Python (v3.7).
 IDLE is written using Tkinter and therefore quite platform-independent.

Package: python3.7-doc
Section: doc
Architecture: all
Depends: libjs-jquery, libjs-underscore, ${misc:Depends}
Suggests: python3.7
Description: Documentation for the high-level object-oriented language Python (v3.7)
 These is the official set of documentation for the interactive high-level
 object-oriented language Python (v3.7). All documents are provided
 in HTML format. The package consists of ten documents:
 .
   * What's New in Python3.7
   * Tutorial
   * Python Library Reference
   * Macintosh Module Reference
   * Python Language Reference
   * Extending and Embedding Python
   * Python/C API Reference
   * Installing Python Modules
   * Documenting Python
   * Distributing Python Modules

Package: python3.7-dbg
Section: debug
Architecture: any
Multi-Arch: allowed
Priority: extra
Depends: python3.7 (= ${binary:Version}), libpython3.7-dbg (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gdb
Suggests: python3-gdbm-dbg, python3-tk-dbg
Description: Debug Build of the Python Interpreter (version 3.7)
 The package holds two things:
 .
 - A Python interpreter configured with --pydebug. Dynamically loaded modules
   are searched as <foo>_d.so first. Third party extensions need a separate
   build to be used by this interpreter.
 - Debug information for standard python interpreter and extensions.
 .
 See the README.debug for more information.

Package: libpython3.7-dbg
Section: debug
Architecture: any
Multi-Arch: same
Priority: extra
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.7-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Debug Build of the Python Interpreter (version 3.7)
 The package holds two things:
 .
 - Extensions for a Python interpreter configured with --pydebug.
 - Debug information for standard python extensions.
 .
 See the README.debug for more information.

=== debian/rules ===
#!/usr/bin/make -f

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
unexport CFLAGS CXXFLAGS LDFLAGS CPPFLAGS

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

vafilt		= $(subst $(2)=,,$(filter $(2)=%,$(1)))
DPKG_VARS	:= $(shell dpkg-architecture)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_HOST_ARCH_ENDIAN	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_ENDIAN)
DEB_HOST_ARCH_OS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

ifeq ($(DEB_HOST_ARCH_OS),linux)
  PLAT = linux
else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
  PLAT = gnukfreebsd10
else ifeq ($(DEB_HOST_ARCH_OS),hurd)
  PLAT = gnu0
else
  $(warning unhandled operating system name: $(DEB_HOST_ARCH_OS))
  PLAT = unknown
endif

CHANGELOG_VARS := $(shell dpkg-parsechangelog | \
	sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE  := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)

LAST_CHANGE := $(shell dpkg-parsechangelog -S Date)
export BUILD_DATE := $(shell LC_ALL=C date -u +'%b %e %Y' -d '$(LAST_CHANGE)')
export BUILD_TIME := $(shell LC_ALL=C date -u +'%H:%M:%S' -d '$(LAST_CHANGE)')

SPHINXOPTS := -D today='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
SPHINXOPTS += -D html_last_updated_fmt='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
export SPHINXOPTS

on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd -o "$$USER" = buildd ] && echo yes)

dh_compat2 := $(shell dpkg --compare-versions "$$(dpkg-query -f '$${Version}' -W debhelper)" lt 9.20150811ubuntu2 && echo DH_COMPAT=2)

ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  WITHOUT_CHECK := yes
endif
WITHOUT_BENCH :=
ifneq (,$(findstring nobench, $(DEB_BUILD_OPTIONS)))
  WITHOUT_BENCH := yes
endif
ifeq ($(on_buildd),yes)
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_CHECK := yes
  endif
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_BENCH := yes
  endif
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  WITHOUT_BENCH := yes
  WITHOUT_CHECK := yes
endif
  WITHOUT_CHECK := yes
  WITHOUT_BENCH := yes

COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

distribution := $(shell lsb_release -is)
distrelease  := $(shell lsb_release -cs)

VER=3.7
SVER=3.7.0~a1
NVER=3.8
PVER=python$(VER)
EXT_VER=$(subst .,,$(VER))
PRIORITY=$(shell echo $(VER) | tr -d '.')0

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)

# default versions are built from the python-defaults source package
# keep the definition to adjust package priorities.
DEFAULT_VERSION = no
STATIC_PYTHON=yes

MIN_MODS := $(shell awk '/^  / && $$2 == "module" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_EXTS := $(shell awk '/^  / && $$2 ~ /^extension/ { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_BUILTINS := $(shell awk '/^  / && $$2 == "builtin" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_PACKAGES := $(shell awk '/^  / && $$2 == "package" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_ENCODINGS := $(foreach i, \
			$(filter-out \
			  big5% bz2% cp932.py cp949.py cp950.py euc_% \
			  gb% iso2022% johab.py shift_jis% , \
			  $(shell cd Lib/encodings && echo *.py)), \
			encodings/$(i)) \
		 codecs.py stringprep.py

with_tk := no
with_interp := static
#with_interp := shared

PY_INTERPRETER = /usr/bin/python$(VER)

ifeq ($(DEFAULT_VERSION),yes)
  PY_PRIO = standard
  #PYSTDDEP = , python (>= $(VER))
else
  PY_PRIO = optional
endif
ifeq ($(distribution),Ubuntu)
  PY_MINPRIO = required
  PY_MINPRIO = optional
  #with_udeb = yes
else
  PY_MINPRIO = $(PY_PRIO)
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  bd_qual = :any
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  ma_filter = cat
else
  ma_filter = grep -v '^Multi-Arch:'
endif
ifneq (,$(filter $(distrelease),sid experimental))
  bd_gcc =
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
  bd_dpkgdev = dpkg-dev (>= 1.17.11),
endif

CC=$(DEB_HOST_GNU_TYPE)-gcc
CXX=$(DEB_HOST_GNU_TYPE)-g++

AR=$(DEB_HOST_GNU_TYPE)-ar
RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib

DPKG_CPPFLAGS:= $(shell dpkg-buildflags --get CPPFLAGS)
DPKG_CFLAGS  := $(shell dpkg-buildflags --get CFLAGS)
DPKG_LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
DEBUG_CFLAGS := $(patsubst -O%,-Og,$(DPKG_CFLAGS))

# on alpha, use -O2 only, use -mieee
ifeq ($(DEB_HOST_ARCH),alpha)
    OPT_CFLAGS += -mieee
    DEBUG_CFLAGS += -mieee
    EXTRA_OPT_FLAGS += -O2
endif
ifeq ($(DEB_HOST_ARCH),m68k)
    EXTRA_OPT_FLAGS += -O2
endif
ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
    OPT_CFLAGS += -fexceptions
    DEBUG_CFLAGS += -fexceptions
endif

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  ifeq ($(DEB_HOST_ARCH_OS),linux)
    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el s390x))
      with_pgo := yes
    endif
  endif
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el s390x))
  with_lto := yes
endif

ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))
    OPT_CFLAGS := $(filter-out -O%, $(OPT_CFLAGS))
    EXTRA_OPT_CFLAGS = -O0
    with_pgo =
    with_lto =
endif

    with_pgo =
    with_lto =

ifeq ($(with_lto),yes)
    LTO_CFLAGS = -g -flto -fuse-linker-plugin
    with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \
			| sed -n '/^$(CC)/s,.* ,,p') ge 4.9 && echo yes)
    ifeq ($(with_fat_lto),yes)
      LTO_CFLAGS += -ffat-lto-objects
    endif
    EXTRA_OPT_CFLAGS += $(LTO_CFLAGS)
    AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
    RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
endif

make_build_target = $(if $(with_pgo),profile-opt)

buildd_static	:= $(CURDIR)/build-static
buildd_shared	:= $(CURDIR)/build-shared
buildd_debug	:= $(CURDIR)/build-debug
buildd_shdebug	:= $(CURDIR)/build-shdebug

d		:= debian/tmp
scriptdir	=  usr/share/lib/python$(VER)
scriptdir	=  usr/share/python$(VER)
scriptdir	=  usr/lib/python$(VER)

# package names and directories
p_base	:= $(PVER)
p_min	:= $(PVER)-minimal
p_lib	:= lib$(PVER)
p_tk	:= $(PVER)-tk
p_dev	:= $(PVER)-dev
p_exam	:= $(PVER)-examples
p_idle	:= idle-$(PVER)
p_doc	:= $(PVER)-doc
p_dbg	:= $(PVER)-dbg
p_udeb	:= $(PVER)-udeb
p_venv	:= $(PVER)-venv

p_lbase	:= lib$(PVER)-stdlib
p_lmin	:= lib$(PVER)-minimal
p_ldev	:= lib$(PVER)-dev
p_ldbg	:= lib$(PVER)-dbg
p_ltst	:= lib$(PVER)-testsuite

d_base	:= debian/$(p_base)
d_min	:= debian/$(p_min)
d_lib	:= debian/$(p_lib)
d_tk	:= debian/$(p_tk)
d_dev	:= debian/$(p_dev)
d_exam	:= debian/$(p_exam)
d_idle	:= debian/$(p_idle)
d_doc	:= debian/$(p_doc)
d_dbg	:= debian/$(p_dbg)
d_udeb	:= debian/$(p_udeb)
d_venv	:= debian/$(p_venv)

d_lbase	:= debian/$(p_lbase)
d_lmin	:= debian/$(p_lmin)
d_ldev	:= debian/$(p_ldev)
d_ldbg	:= debian/$(p_ldbg)
d_ltst	:= debian/$(p_ltst)

build-arch: stamps/stamp-build
build-indep: stamps/stamp-build-doc
build: build-arch
stamps/stamp-build: stamps/stamp-build-static stamps/stamp-mincheck \
    stamps/stamp-build-shared stamps/stamp-build-debug \
    stamps/stamp-build-shared-debug \
    stamps/stamp-check stamps/stamp-pybench
	touch $@

PROFILE_EXCLUDES = test_compiler test_distutils test_subprocess \

## python3.7 3.7.0~b3

=== debian/changelog ===
python3.7 (3.7.0~b3-1) unstable; urgency=medium

  * Python 3.7.0 beta 3 release.
  * libpython3.7-stdlib: Add missing python3-distutils breaks. Closes: #894204.

 -- Matthias Klose <doko@debian.org>  Fri, 30 Mar 2018 12:35:22 +0800

python3.7 (3.7.0~b2-2) unstable; urgency=medium

  * libpython3.7-stdlib: Ship again distutils/{__init__,version}.py.

 -- Matthias Klose <doko@debian.org>  Fri, 23 Mar 2018 11:21:34 +0800

python3.7 (3.7.0~b2-1) unstable; urgency=medium

  * Python 3.7.0 beta 2 release.
    - Fix issue #32185: The SSL module no longer sends IP addresses in SNI TLS
      extension on platforms with OpenSSL 1.0.2+ or inet_pton. See #892814.
  * Add support for riscv64 (Aurelien Jarno). Addresses: #892328.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Tue, 13 Mar 2018 20:55:14 +0100

python3.7 (3.7.0~b1-1) unstable; urgency=medium

  * Python 3.7.0 beta 1 release.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Thu, 01 Feb 2018 08:36:28 +0100

python3.7 (3.7.0~a4-1) unstable; urgency=medium

  * Python 3.7.0 alpha 4 release.

 -- Matthias Klose <doko@debian.org>  Wed, 10 Jan 2018 13:34:16 +0100

python3.7 (3.7.0~a3-4) unstable; urgency=medium

  * Stop building python3.7-2to3, now replaced by 2to3 and python3-lib2to3.

 -- Matthias Klose <doko@debian.org>  Fri, 05 Jan 2018 03:45:13 +0100

python3.7 (3.7.0~a3-3) unstable; urgency=medium

  * Stop shipping lib2to3, now shipped in python3-lib2to3.

 -- Matthias Klose <doko@debian.org>  Wed, 27 Dec 2017 14:04:53 +0100

python3.7 (3.7.0~a3-2) unstable; urgency=medium

  * Split out a python3.7-2to3 package.
  * Stop shipping the tkinter and distutils modules in libpython3.7-stdlib.

 -- Matthias Klose <doko@debian.org>  Wed, 13 Dec 2017 12:18:54 +0100

python3.7 (3.7.0~a3-1) unstable; urgency=medium

  * Python 3.7.0 alpha 3 release.
  * Add support for mipsr6 triplets (YunQiang Su). Addresses: #881942.
  * Move the idle library into the idle-python3.7 package.
  * Build documentation in info format (Benjamin Moody). Addresses: #881959.

 -- Matthias Klose <doko@debian.org>  Wed, 06 Dec 2017 13:24:25 +0100

=== debian/control ===
--- 
+++ 
@@ -16,8 +16,8 @@
   libgpm2 [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
   mime-support, netbase, bzip2, time, python3:any,
   net-tools, xvfb, xauth
-Build-Depends-Indep: python3-sphinx
-Standards-Version: 4.1.0
+Build-Depends-Indep: python3-sphinx, texinfo
+Standards-Version: 4.1.3
 Vcs-Browser: https://code.launchpad.net/~doko/python/pkg3.7-debian
 Vcs-Bzr: http://bazaar.launchpad.net/~doko/python/pkg3.7-debian
 XS-Testsuite: autopkgtest
@@ -26,7 +26,10 @@
 Architecture: any
 Multi-Arch: allowed
 Priority: optional
-Depends: python3.7-minimal (= ${binary:Version}), libpython3.7-stdlib (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
+Depends: python3.7-minimal (= ${binary:Version}),
+ libpython3.7-stdlib (= ${binary:Version}),
+ mime-support,
+ ${shlibs:Depends}, ${misc:Depends}
 Suggests: python3.7-venv, python3.7-doc, binutils
 Description: Interactive high-level object-oriented language (version 3.7)
  Python is a high-level, interactive, object-oriented language. Its 3.7 version
@@ -53,7 +56,9 @@
 Priority: optional
 Pre-Depends: ${misc:Pre-Depends}
 Depends: libpython3.7-minimal (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
-Breaks: libmpdec2 (<< 2.4.2)
+Breaks: python3-tk (<< 3.6.4~rc1-2), libmpdec2 (<< 2.4.2),
+  python3-distutils (<< 3.6.5~rc1-2),
+Replaces: python3-distutils (<< 3.6.5~rc1-2),
 Description: Interactive high-level object-oriented language (standard library, version 3.7)
  Python is a high-level, interactive, object-oriented language. Its 3.7 version
  includes an extensive class library with lots of goodies for
@@ -84,7 +89,8 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: libpython3.7-stdlib
-Conflicts: binfmt-support (<< 1.1.2)
+Breaks: libpython3.7-stdlib (<< 3.7.0~b2-1~)
+Conflicts: binfmt-support (<< 1.1.2), libpython3.7-stdlib (<< 3.7.0~b2-1~)
 Description: Minimal subset of the Python language (version 3.7)
  This package contains some essential modules. It is normally not
  used on it's own, but as a dependency of python3.7-minimal.
@@ -156,6 +162,8 @@
 Architecture: all
 Depends: python3.7, python3-tk, python3.7-tk, ${misc:Depends}
 Enhances: python3.7
+Breaks: libpython3.7-stdlib (<< 3.7.0~a3-1)
+Replaces: libpython3.7-stdlib (<< 3.7.0~a3-1)
 Description: IDE for Python (v3.7) using Tkinter
  IDLE is an Integrated Development Environment for Python (v3.7).
  IDLE is written using Tkinter and therefore quite platform-independent.
@@ -185,7 +193,6 @@
 Section: debug
 Architecture: any
 Multi-Arch: allowed
-Priority: extra
 Depends: python3.7 (= ${binary:Version}), libpython3.7-dbg (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Recommends: gdb
 Suggests: python3-gdbm-dbg, python3-tk-dbg
@@ -203,7 +210,6 @@
 Section: debug
 Architecture: any
 Multi-Arch: same
-Priority: extra
 Pre-Depends: ${misc:Pre-Depends}
 Depends: libpython3.7-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Description: Debug Build of the Python Interpreter (version 3.7)

=== debian/tests/control ===
Tests: testsuite
Depends: build-essential, locales, python3.7-dev, libpython3.7-testsuite, python3-gdbm, python3-distutils
# need to turn off apport
Restrictions: needs-root

Tests: testsuite-dbg
Depends: build-essential, locales, python3.7-dev, python3.7-dbg, libpython3.7-testsuite, python3-gdbm-dbg, gdb, python3-distutils
# need to turn off apport
Restrictions: needs-root

Tests: failing-tests
Depends: build-essential, locales, python3.7-dev, libpython3.7-testsuite, python3-gdbm, python3-distutils
# need to turn off apport
Restrictions: needs-root allow-stderr

Tests: failing-tests-dbg
Depends: build-essential, locales, python3.7-dev, python3.7-dbg, libpython3.7-testsuite, python3-gdbm-dbg, gdb, python3-distutils
# need to turn off apport
Restrictions: needs-root allow-stderr
